#AMS2 Random Race Generator for Dedicated Server ver 1.0 Jacek Slaby 18-08-2023



clear
$num_races = Read-Host -Prompt 'How many random races you want in loop?'


# here is a part of sms_rotate_config.json file, which will be randomized

$wyscig = ' {
		    "VehicleClassId" : "GT4",
	      //"VehicleModelId" : "Ultima GTR Race",
			"MultiClassSlots" : 0,
	        "MultiClassSlot1" : "GTE",
	        "MultiClassSlot2" : "GTE",
	        "MultiClassSlot3" : "Cat_Academy",

			"TrackId" : "Spielberg_Modern",

			"RaceDateHour" : 11,
			"RaceDateDay" : 20,
			"RaceDateMonth" : 8,
			"RaceDateYear" : 2020,
            "RaceDateProgression" : 1,
			
			"RaceMandatoryPitStops" : 0,
			"DisablePitstopRefuelling" : 0,
            
            "GridLayout" : 4

			
			"PracticeWeatherSlots" :1,
		"PracticeWeatherSlot1" : "LightCloud",
		"PracticeWeatherSlot2" : "LightCloud",
		"PracticeWeatherSlot3" : "LightCloud",
		"PracticeWeatherSlot4" : "Clear",

		"QualifyWeatherSlots" : 1,
		"QualifyWeatherSlot1" : "Clear",
		"QualifyWeatherSlot2" : "Clear",
		"QualifyWeatherSlot3" : "LightRain",
		"QualifyWeatherSlot4" : "LightRain",

		"RaceWeatherSlots" : 1,
		"RaceWeatherSlot1" : "LightCloud",
		"RaceWeatherSlot2" : "LightCloud",
		"RaceWeatherSlot3" : "MediumCloud",
		"RaceWeatherSlot4" : "Hazy",
			
			"FullCourseYellows" : 0,
			"RaceFormationLap" : 0,
			"RaceRollingStart" : 0,
			"ManualRollingStarts" : 0,

			"PracticeLength" : 5,
			"PracticeDateHour" : 8,
			"PracticeDateProgression" : 5,
			"QualifyLength" : 0,
			"QualifyDateHour" : 12,
			"RaceLength" : 5m,
			"RaceExtraLap" : 1,

			"TireWearType": "X2",
			"FuelUsageType": "X2",
			
			"PracticeLiveTrackPreset" : "Light Rubber",
		"QualifyLiveTrackPreset" : "Default Progressing",
		"RaceLiveTrackPreset" : "Default Progressing",
},'

# here is static begining of the file
$begin = '// Config version.
version : 7

// Default configuration.
config : {

	// Is the current rotation index persistent? If true, the rotation will continue after server restart,
	// If false, the rotation will always start from the first setup.
	// You can always delete the sms_rotate_data.json file from lua_config to reset the persisted index.
	"persist_index" : false,

	// The default setup. This is a table with attributes and values. The following rules apply to the attributes:
	// - If TrackId is specified: The track to enforce. Automatically sets 1 to ServerControlsTrack
	// - If VehicleModelId is specified: The vehicle to enforce. Automatically sets 1 to ServerControlsVehicle, sets FORCE_IDENTICAL_VEHICLES to Flags
	// - If VehicleClassId is specified: The class to enforce. Automatically sets 1 to ServerControlsVehicleClass, sets FORCE_SAME_VEHICLE_CLASS to Flags
	// - Track, vehicle model, vehicle class and all enum/flags attributes can use values in string forms - so you can use either track id, or track name.
	// - Flags in string form can contain multiple flags separated by comma, so for example "ABS_ALLOWED,SC_ALLOWED,TCS_ALLOWED"
	// - The setup should never contain any of the "ServerControls" attributes, those are decided automatically.
	// - The setup should never contain both VehicleModelId and VehicleClassId at the same time. Restrict either the class or specific vehicle.
	// - The Flags attribute should never contain FORCE_IDENTICAL_VEHICLES or FORCE_SAME_VEHICLE_CLASS flags, those are decided automatically.
	"default" : {

		"MinimumOnlineRank" : "U",
		"MinimumOnlineStrength" : 100,

		"PracticeLength" : 15,
		"PracticeDateHour" : 9,
		"QualifyLength" : 15,
		"QualifyDateHour" : 12,
		"RaceLength" : 15,
		"RaceExtraLap" : 0,
       
	   
		"GridLayout" : 0	
			
			
			
	   
	   
	   
		// ONLINE_REPUTATION_ENABLED,MECHANICAL_FAILURES,
		"Flags" : "ALLOW_CUSTOM_VEHICLE_SETUP,TIMED_RACE,FORCE_REALISTIC_DRIVING_AIDS,TCS_ALLOWED,ABS_ALLOWED,FORCE_MANUAL,AUTO_START_ENGINE,WAIT_FOR_RACE_READY_INPUT,DISABLE_DRIVING_LINE,FILL_SESSION_WITH_AI", 
		"DamageType" : "PERFORMANCEIMPACTING",
		"DamageScale" : 1,
		"TireWearType" : "X2",
		"FuelUsageType" : "X2",
		"AllowedViews" : 2,
        "PitSpeedLimit" : 100,
		
		"DisablePitstopRefuelling" : 0,

		"PenaltiesType" : "FULL",
		"AllowedCutsBeforePenalty": 3,

		"RaceMandatoryPitStops" : 0,
		"RaceRollingStart" : 0,
		"ManualRollingStarts" : 0,
        "RaceFormationLap" : 0,		 
		"FullCourseYellows" : 0,
		 
		"RaceDateHour" : 13,
		"RaceDateDay" : 10,
		"RaceDateMonth" : 05,
		"RaceDateYear" : 2021,

		"OpponentDifficulty" : 78,

		"PracticeDateProgression" : 2,
		"QualifyDateProgression" : 1,
		"RaceDateProgression" : 2,


		"PracticeWeatherSlots" : 1,
		"PracticeWeatherSlot1" : "Clear",
		"PracticeWeatherSlot2" : "Random",
		"PracticeWeatherSlot3" : "Random",
		"PracticeWeatherSlot4" : "Random",

		"QualifyWeatherSlots" : 1,
		"QualifyWeatherSlot1" : "Clear",
		"QualifyWeatherSlot2" : "Random",
		"QualifyWeatherSlot3" : "Random",
		"QualifyWeatherSlot4" : "Random",

		"RaceWeatherSlots" : 1,
		"RaceWeatherSlot1" : "Clear",
		"RaceWeatherSlot2" : "Random",
		"RaceWeatherSlot3" : "Random",
		"RaceWeatherSlot4" : "Clear",

		"ManualPitStops" : 1,

		"MultiClassSlots" : 0,
		"MultiClassSlot1" : "GT3",
		"MultiClassSlot2" : "GT4",
		"MultiClassSlot3" : "GT5",
		"MultiClassSlot4" : "P2",
		"MultiClassSlot5" : "P3",
		//"MultiClassSlot6" : "GT5",
		//"MultiClassSlot7" : "GT5",
		//"MultiClassSlot8" : "GT5",
		//"MultiClassSlot9" : "GT5",

		"PracticeLiveTrackPreset" : "Medium Rubber",
		"QualifyLiveTrackPreset" : "Default Progressing",
		"RaceLiveTrackPreset" : "Default Progressing",
	},

	// The rotation. Array of setups to rotate. If empty, just the default setup will be used with no actual rotation happening.
	//
	// These setups are applied on top of the default setup, then applied to the game. Previous setup in the rotation is never used.
	// So for example if you wanted to repeat the same track in multiple consecutive setups, different from the default track,
	// each of those setups needs to explicitly include that track. Also remember that apart from the flags nothing can be "removed"
	// from the default setup, so if the default setup contains a track, some track will always be enforced (either the default one,
	// or the setup-specific one). And one last thing, these override setups can never include an attribute thats not specified in
	// the default setup - it can just override some of the default attributes, not add new ones. The only exception are the
	// track/vehicle/class attributes.
	//
	// Attributes in these setups can have a special attribute RemoveFlags set, which will remove the specified flags from the default
	// setup instead of adding them to it (which is what the Flags attribute will do)
	"rotation" : [

		// // EVENT 1'

# some leftovers on the end of file
$endoffile = '	]
}'



# this will be our temporary file we will build and copy it over original sms_rotate_config.json file 
set-content -Path .\wynik.txt -Value $begin


# will loop generate given number of races 
for ($i = 1;$i -le $num_races;$i++)
{

$random_track = Get-Random -InputObject (get-content .\tracks.txt)
$tekscik = '"TrackId" : "'+$random_track+'"'
$tekscik
$nowy_wyscig = $wyscig -replace '"TrackId" : "Spielberg_Modern"',$tekscik



$random_carclass = Get-Random -InputObject (get-content .\cars.txt)
$tekscik = '"VehicleClassId" : "'+$random_carclass+'"'
$tekscik
$nowy_wyscig = $nowy_wyscig -replace '"VehicleClassId" : "GT4"',$tekscik


$random_weather = Get-Random -InputObject (get-content .\weather.txt)
$random_weather_slots = Get-Random -InputObject (get-content .\weather_slots.txt)
$tekscik = '"RaceWeatherSlot1" : '+$random_weather
$nowy_wyscig = $nowy_wyscig -replace '"RaceWeatherSlot1" : "LightCloud"',$tekscik
$tekscik

$random_weather = Get-Random -InputObject (get-content .\weather.txt)
$tekscik = '"RaceWeatherSlot2" : '+$random_weather
$nowy_wyscig = $nowy_wyscig -replace '"RaceWeatherSlot2" : "LightCloud"',$tekscik
$tekscik

$random_weather = Get-Random -InputObject (get-content .\weather.txt)
$tekscik = '"RaceWeatherSlot3" : '+$random_weather
$nowy_wyscig = $nowy_wyscig -replace '"RaceWeatherSlot3" : "LightCloud"',$tekscik
$tekscik

$random_weather = Get-Random -InputObject (get-content .\weather.txt)
$tekscik = '"RaceWeatherSlot4" : '+$random_weather
$nowy_wyscig = $nowy_wyscig -replace '"RaceWeatherSlot4" : "LightCloud"',$tekscik
$tekscik


$tekscik = '"RaceWeatherSlots" : '+$random_weather_slots
$nowy_wyscig = $nowy_wyscig -replace '"RaceWeatherSlots" : 1',$tekscik
$tekscik



$random_length = Get-Random -InputObject (get-content .\race_length.txt)
$tekscik = '"RaceLength" : '+$random_length
$nowy_wyscig = $nowy_wyscig -replace '"RaceLength" : 5m',$tekscik
$tekscik


#rolling start in 30% races
$random_rolling = get-random -Maximum 100
if($random_rolling -lt 30) {
$nowy_wyscig = $nowy_wyscig -replace '"RaceRollingStart" : 0','"RaceRollingStart" : 1'
$random_rolling
}


#Mandatory pit in 25% races
$random_pit = get-random -Maximum 100
if($random_pit -lt 25) {
$nowy_wyscig = $nowy_wyscig -replace '"RaceMandatoryPitStops" : 0','"RaceMandatoryPitStops" : 1'
$random_pit
}

Write-Host "------------------------------------"






#$nowy_wyscig



add-content -Path .\wynik.txt -Value $nowy_wyscig


}

add-content -Path .\wynik.txt -Value $endoffile



#copy result file over original
Copy-Item .\wynik.txt -Destination ..\lua_config\sms_rotate_config.json -force -Verbose

#last moment to say a prayer or analyze generated events
pause


#start Dedicated Server
cd ..
Start-Process  .\DedicatedServerCmd.exe